# Class ModulePackages

java.lang.Object
org.apache.bcel.classfile.Attribute
org.apache.bcel.classfile.ModulePackages

All Implemented Interfaces:
  `Cloneable, Node`

public final class ModulePackages extends Attribute
This class is derived from Attribute and represents the list of packages that are exported or opened by the Module attribute. There may be at most one ModulePackages attribute in a ClassFile structure.

See Also:
  - `Attribute`

- ## Field Summary

  ### Fields inherited from class Attribute

  `constant_pool, EMPTY_ARRAY, length, name_index, tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ModulePackages(int nameIndex, int length, int[] packageIndexTable, ConstantPool constantPool)`
  `ModulePackages(ModulePackages c)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `Attribute`
  `copy(ConstantPool constantPool)`
  `void`
  `dump(DataOutputStream file)`
  Dump ModulePackages attribute to file stream in binary format.
  `int`
  `getNumberOfPackages()`
  `int[]`
  `getPackageIndexTable()`
  `String[]`
  `getPackageNames()`
  `void`
  `setPackageIndexTable(int[] packageIndexTable)`
  `String`
  `toString()`

  ### Methods inherited from class Attribute

  `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ModulePackages

    public ModulePackages(int nameIndex, int length, int[] packageIndexTable, ConstantPool constantPool)
    Parameters:
      `nameIndex` - Index in constant pool
      `length` - Content length in bytes
      `packageIndexTable` - Table of indices in constant pool
      `constantPool` - Array of constants

  - ### ModulePackages

    public ModulePackages(ModulePackages c)
    Initialize from another object. Note that both objects use the same references (shallow copy). Use copy() for a physical copy.
    Parameters:
      `c` - Source to copy.

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Attribute`
    Parameters:
      `v` - Visitor object

  - ### copy

    public Attribute copy(ConstantPool constantPool)
    Specified by:
      `copy` in class `Attribute`
    Parameters:
      `constantPool` - constant pool to save.
    Returns:
      deep copy of this attribute

  - ### dump

    public void dump(DataOutputStream file) throws IOException
    Dump ModulePackages attribute to file stream in binary format.
    Overrides:
      `dump` in class `Attribute`
    Parameters:
      `file` - Output file stream
    Throws:
      `IOException` - if an I/O error occurs.

  - ### getNumberOfPackages

    public int getNumberOfPackages()
    Returns:
      Length of package table.

  - ### getPackageIndexTable

    public int[] getPackageIndexTable()
    Returns:
      array of indices into constant pool of package names.

  - ### getPackageNames

    public String[] getPackageNames()
    Returns:
      string array of package names

  - ### setPackageIndexTable

    public void setPackageIndexTable(int[] packageIndexTable)
    Parameters:
      `packageIndexTable` - the list of package indexes Also redefines number_of_packages according to table length.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Attribute`
    Returns:
      String representation, i.e., a list of packages.